//#include "ext.h"
//#include "z_dsp.h"

#include "m_pd.h"

#include <math.h>

/*******************************************************************/
/*  LP multigain objet dynamiquement modifiable nombre de sorties  */
/*                janvier 2003 - GMEM                              */
/*******************************************************************/
static t_class *multigain_class;


typedef struct _multigain
{
    t_object x_obj;
	float x_scal;		// distance de la source entre le centre (0.) et les HP (1.)
	float x_teta;		// angle entre 0. et 1.****
	

	float x_hp[17];

    int  x_nouts;		/* number of outputs */

	t_outlet * x_outlets[16];

	float x_f;
} t_multigain;

float spat (float x, float d, int n);
float spat2 (float x, float d);
void *multigain_new(float val);

void multigain_floatval(t_multigain *x, float f);
void multigain_floatval2(t_multigain *x);
void multigain_floatval3(t_multigain *x);
void multigain_floatval4(t_multigain *x);
void multigain_floatval5(t_multigain *x);
void multigain_floatval6(t_multigain *x);
void multigain_floatval7(t_multigain *x);
void multigain_floatval8(t_multigain *x);
void multigain_floatval9(t_multigain *x);
void multigain_floatval10(t_multigain *x);
void multigain_floatval11(t_multigain *x);
void multigain_floatval12(t_multigain *x);
void multigain_floatval13(t_multigain *x);
void multigain_floatval14(t_multigain *x);
void multigain_floatval15(t_multigain *x);
void multigain_floatval16(t_multigain *x);
void multigain_floatdist(t_multigain *x, float f);


void multigain_spitout(t_multigain *x);

void multigain_setup(void)
{
    multigain_class = class_new(gensym("multigain"), (t_newmethod)multigain_new, CLASS_DEFAULT, (short)sizeof(t_multigain), 0, A_DEFFLOAT, 0);
    class_addfloat(multigain_class,multigain_floatval);

    class_addmethod(multigain_class, (t_method)multigain_floatdist, gensym("dist"), A_DEFFLOAT, 0);



	class_sethelpsymbol(multigain_class, gensym("multigain"));

	post("multigain GMEM Marseille France");

}

void *multigain_new(float val)
{
    t_multigain *x = (t_multigain *)pd_new(multigain_class);




  	inlet_new(&x->x_obj, &x->x_obj.ob_pd, gensym("float"), gensym("dist"));


   	
   	val = (val < 2 ? 1 : val) ;
   	val = (val > 16 ? 16 : val) ;
   	
   	x->x_nouts = val;


	x->x_outlets[0] = outlet_new(&x->x_obj, &s_float);

	x->x_outlets[1] = outlet_new(&x->x_obj, &s_float);

    
    if (val > 2)
		x->x_outlets[2] = outlet_new(&x->x_obj, &s_float);

    if (val > 3)
		x->x_outlets[3] = outlet_new(&x->x_obj, &s_float);

    if (val > 4)
		x->x_outlets[4] = outlet_new(&x->x_obj, &s_float);

    if (val > 5)
		x->x_outlets[5] = outlet_new(&x->x_obj, &s_float);

    if (val > 6)
		x->x_outlets[6] = outlet_new(&x->x_obj, &s_float);

    if (val > 7)
		x->x_outlets[7] = outlet_new(&x->x_obj, &s_float);

    if (val > 8)
		x->x_outlets[8] = outlet_new(&x->x_obj, &s_float);

    if (val > 9)
		x->x_outlets[9] = outlet_new(&x->x_obj, &s_float);

    if (val > 10)
		x->x_outlets[10] = outlet_new(&x->x_obj, &s_float);

    if (val > 11)
		x->x_outlets[11] = outlet_new(&x->x_obj, &s_float);

    if (val > 12)
		x->x_outlets[12] = outlet_new(&x->x_obj, &s_float);

    if (val > 13)
		x->x_outlets[13] = outlet_new(&x->x_obj, &s_float);

    if (val > 14)
		x->x_outlets[14] = outlet_new(&x->x_obj, &s_float);

    if (val > 15)
		x->x_outlets[15] = outlet_new(&x->x_obj, &s_float);

	

	x->x_hp[1] 	= 0. ;	
	x->x_hp[2]	= 0. ;	
	x->x_hp[3] 	= 0. ;	
	x->x_hp[4] 	= 0. ;	
	x->x_hp[5] 	= 0. ;	
	x->x_hp[6] 	= 0. ;	
	x->x_hp[7] 	= 0. ;	
	x->x_hp[8] 	= 0. ;	
	x->x_hp[9] 	= 0. ;	
	x->x_hp[10] = 0. ;	
	x->x_hp[11] = 0. ;	
	x->x_hp[12] = 0. ;	
	x->x_hp[13] = 0. ;	
	x->x_hp[14] = 0. ;	
	x->x_hp[15] = 0. ;	
	x->x_hp[16] = 0. ;	


	x->x_scal = 1. ;
    x->x_teta = 0. ;
     
    return (x);
}


	
/*****************************************/
float spat2 (float x, float d)
{
	float x1;
	
	x1 = fmod(x, 1.0) ;
	x1 = (x1 < 0.5 ? 0.5 - x1 : x1 - 0.5) ; // x1 = abs(x - 0.5) ;
	x1 = (1 - (x1 * 2 * d)) ; 				// fct linaire ;
	x1 = (x1 < 0 ? 0 : x1) ; 				//  max(0, (1 - (x1 * 2)) ;
	// return pow(x1 , 0.5) * ((d / 2) + 0.5) ;// (racine de x1) compense pour la distance; ? ou
	return pow(x1 * ((d / 2) + 0.5) , 0.5)  ; //   racine de (x1 compens pour la distance) ?
}

float spat (float x, float d, int n)
{
	float x1;
	
	x1 = fmod(x, 1.0) ;
	x1 = (x1 < 0.5 ? 0.5 - x1 : x1 - 0.5) ; // x1 = abs(x - 0.5) ;
	x1 = (1 - (x1 * n * d)) ; // fct linaire ;
	x1 = (x1 < 0 ? 0 : x1) ; //  max(0, (1 - (x1 * 3)) ;
	return pow(x1 , 0.5) * ((d / 2) + 0.5) ; // (racine de x1) compense pour la distance;
}

/***************************************/
void multigain_floatval(t_multigain *x, float teta)
{
	teta = (teta < 0 ? 0 : teta) ;
	x->x_teta = teta ;


	switch (x->x_nouts) {	
		case 2: multigain_floatval2 (x) ;
			break ;
		case 3: multigain_floatval3 (x) ;
			break ;
		case 4: multigain_floatval4 (x) ;
			break ;
		case 5: multigain_floatval5 (x) ;
			break ;
		case 6: multigain_floatval6 (x) ;
			break ;
		case 7: multigain_floatval7 (x) ;
			break ;
		case 8: multigain_floatval8 (x) ;
			break ;
		case 9: multigain_floatval9 (x) ;
			break ;
		case 10: multigain_floatval10 (x) ;
			break ;
		case 11: multigain_floatval11 (x) ;
			break ;
		case 12: multigain_floatval12 (x) ;
			break ;
		case 13: multigain_floatval13 (x) ;
			break ;
		case 14: multigain_floatval14 (x) ;
			break ;
		case 15: multigain_floatval15 (x) ;
			break ;
		case 16: multigain_floatval16 (x) ;
	}
	
	multigain_spitout(x);
	
}

void multigain_floatval2(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	x->x_hp[1] = spat2( teta + 0.5, d) ;	
	x->x_hp[2] = spat2( teta + 0.0, d) ;	
}
void multigain_floatval3(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval4(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval5(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval6(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval7(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval8(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval9(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1]  = spat( teta + 0.5, d, n) ;	
	x->x_hp[2]  = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3]  = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4]  = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5]  = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6]  = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[7]  = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[8]  = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[9]  = spat( teta + 0.5 + (1 * delta), d, n) ;		
}

void multigain_floatval10(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multigain_floatval11(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[11] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}
void multigain_floatval12(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[11] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[12] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multigain_floatval13(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[11] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[12] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[13] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multigain_floatval14(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 - (7 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp[11] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[12] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[13] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[14] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}


void multigain_floatval15(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 - (7 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 + (7 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp[11] = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp[12] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[13] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[14] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[15] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}

void multigain_floatval16(t_multigain *x)
{
	double teta = x->x_teta ;
	float d = x->x_scal ;
	int n = x->x_nouts ;
	float delta = 1./(float)n ;
	x->x_hp[1] = spat( teta + 0.5, d, n) ;	
	x->x_hp[2] = spat( teta + 0.5 - (1 * delta), d, n) ;	
	x->x_hp[3] = spat( teta + 0.5 - (2 * delta), d, n) ;	
	x->x_hp[4] = spat( teta + 0.5 - (3 * delta), d, n) ;	
	x->x_hp[5] = spat( teta + 0.5 - (4 * delta), d, n) ;	
	x->x_hp[6] = spat( teta + 0.5 - (5 * delta), d, n) ;	
	x->x_hp[7] = spat( teta + 0.5 - (6 * delta), d, n) ;	
	x->x_hp[8] = spat( teta + 0.5 - (7 * delta), d, n) ;	
	x->x_hp[9] = spat( teta + 0.5 - (8 * delta), d, n) ;	
	x->x_hp[10] = spat( teta + 0.5 + (7 * delta), d, n) ;	
	x->x_hp[11] = spat( teta + 0.5 + (6 * delta), d, n) ;	
	x->x_hp[12] = spat( teta + 0.5 + (5 * delta), d, n) ;	
	x->x_hp[13] = spat( teta + 0.5 + (4 * delta), d, n) ;	
	x->x_hp[14] = spat( teta + 0.5 + (3 * delta), d, n) ;	
	x->x_hp[15] = spat( teta + 0.5 + (2 * delta), d, n) ;	
	x->x_hp[16] = spat( teta + 0.5 + (1 * delta), d, n) ;	
}



/***************************************/
void multigain_floatdist(t_multigain *x, float d)
{
	d = (d > 1. ? 1. : d) ;
	d = (d < 0. ? 0. : d) ;


	x->x_scal = d ;

	switch (x->x_nouts) {	
		case 2: multigain_floatval2 (x) ;
			break ;
		case 3: multigain_floatval3 (x) ;
			break ;
		case 4: multigain_floatval4 (x) ;
			break ;
		case 5: multigain_floatval5 (x) ;
			break ;
		case 6: multigain_floatval6 (x) ;
			break ;
		case 7: multigain_floatval7 (x) ;
			break ;
		case 8: multigain_floatval8 (x) ;
			break ;
		case 9: multigain_floatval9 (x) ;
			break ;
		case 10: multigain_floatval10 (x) ;
			break ;
		case 11: multigain_floatval11 (x) ;
			break ;
		case 12: multigain_floatval12 (x) ;
			break ;
		case 13: multigain_floatval13 (x) ;
			break ;
		case 14: multigain_floatval14 (x) ;
			break ;
		case 15: multigain_floatval15 (x) ;
			break ;
		case 16: multigain_floatval16 (x) ;
	}
	
	multigain_spitout(x);

}

/**********************************************************/
/* 0 = entree gauche, 1 = control de pan, ensuite sorties */


void multigain_spitout(t_multigain *x)
{
	int i;
	for ( i=x->x_nouts-1; i>=0; i--)
		outlet_float(x->x_outlets[i],x->x_hp[i+1]);
}


